//+------------------------------------------------------------------+
//|                                               Stoch_MySiMPLE.mq4 |
//|                                        Copyright  2008, masemus |
//|                                                masemus@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, masemus"
#property link      "masemus@yahoo.com"

#property indicator_separate_window
#property indicator_maximum 150
#property indicator_minimum -50
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Magenta
#property indicator_color4 Aqua
#property indicator_color5 Gray
#property indicator_color6 Gray
#property indicator_color7 Gray
#property indicator_color8 DarkKhaki
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1
#property indicator_level1 100
#property indicator_level2 80
#property indicator_level3 20
#property indicator_level4 0
//
extern int p_K=8;
extern int p_D=5;
extern int p_S=3;
extern int MA_method=MODE_SMA;
extern int BBands=20;
extern int Dev=2;
extern bool candleTIME=true;
extern int cTiME_clr=DarkKhaki;
//
double cbb1;
double pbb1;
//
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double avg[];
double sDev[];
double upBB[];
double loBB[];
//
double s1[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
//---- additional buffers are used for counting
   IndicatorBuffers(8);
//---- indicator buffers mapping
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(0,buffer1); 
   SetIndexBuffer(1,buffer2); 
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,avg);
   SetIndexBuffer(5,upBB);
   SetIndexBuffer(6,loBB);
   SetIndexBuffer(7,buffer5);
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Stoch_MySiMPLE ("+p_K+","+p_D+","+p_S+") :: ["+BBands+","+Dev+"] ::");
//---- initialization done
   return(0);
}

//
int deinit()
{
   ObjectDelete("time");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int limit,counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++)
      buffer3[i]=iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_MAIN,i);
   //
   for(i=limit; i>=0; i--)
   {
      buffer4[i]=iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_SIGNAL,i);

      avg[i]=iMAOnArray(buffer3,0,BBands,0,MA_method,i);
      sDev[i]=iStdDevOnArray(buffer3,0,BBands,0,MA_method,i);
      upBB[i]=iMAOnArray(buffer3,0,BBands,0,MA_method,i)+(Dev*(iStdDevOnArray(buffer3,0,BBands,0,MA_method,i)));
      loBB[i]=iMAOnArray(buffer3,0,BBands,0,MA_method,i)-(Dev*(iStdDevOnArray(buffer3,0,BBands,0,MA_method,i)));

      buffer5[i]=(iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_MAIN,i)
                 -iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_SIGNAL,i))*1;

      cbb1=(iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_MAIN,i)
           -iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_SIGNAL,i))*1;
      pbb1=(iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_MAIN,i+1)
           -iStochastic(Symbol(),0,p_K,p_D,p_S,MA_method,0,MODE_SIGNAL,i+1))*1;

   bool up=true;
      if(cbb1>pbb1) up=true;
      if(cbb1<pbb1) up=false;
      if(!up)
        {
         buffer1[i]=cbb1;
         buffer2[i]=0.0;
        }
      else
        {
         buffer2[i]=cbb1;
         buffer1[i]=0.0;
        }
   }

   //
   if(candleTIME == true) {
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   //
   ObjectDelete("time");
   //
   if(ObjectFind("time") != 0)
   {
   ObjectCreate("time", OBJ_TEXT, 0, Time[0], Close[0]+ 0.0005);
   ObjectSetText("time", "               < "+m+":"+s, 10, "Arial", cTiME_clr);
   }
   else
   {
   ObjectMove("time", 0, Time[0], Close[0]+0.0005);
   }

   }
//---- done
   return(0);
}
//+------------------------------------------------------------------+

